VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "comdlg32.ocx"
Begin VB.Form Form1 
   Caption         =   "Valentina Example: Single table"
   ClientHeight    =   4815
   ClientLeft      =   165
   ClientTop       =   855
   ClientWidth     =   6480
   LinkTopic       =   "Form1"
   ScaleHeight     =   4815
   ScaleMode       =   0  'User
   ScaleWidth      =   6480
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton btnDelete 
      Caption         =   "Delete"
      Height          =   300
      Left            =   3868
      TabIndex        =   12
      Top             =   4320
      Width           =   1000
   End
   Begin VB.CommandButton btnUpdate 
      Caption         =   "Update"
      Height          =   300
      Left            =   2743
      TabIndex        =   11
      Top             =   4320
      Width           =   1000
   End
   Begin VB.CommandButton btnAdd 
      Caption         =   "Add"
      Height          =   300
      Left            =   1613
      TabIndex        =   10
      Top             =   4320
      Width           =   1000
   End
   Begin VB.CommandButton btnFirst 
      Caption         =   "First"
      Height          =   300
      Left            =   1050
      TabIndex        =   9
      Top             =   3600
      Width           =   1000
   End
   Begin VB.CommandButton btnLast 
      Caption         =   "Last"
      Height          =   300
      Left            =   4430
      TabIndex        =   8
      Top             =   3600
      Width           =   1000
   End
   Begin VB.CommandButton btnNext 
      Caption         =   "Next"
      Height          =   300
      Left            =   3305
      TabIndex        =   7
      Top             =   3600
      Width           =   1000
   End
   Begin VB.CommandButton btnPrev 
      Caption         =   "Prev"
      Height          =   300
      Left            =   2180
      TabIndex        =   6
      Top             =   3600
      Width           =   1000
   End
   Begin VB.TextBox fVBinary 
      Height          =   285
      Left            =   1560
      TabIndex        =   5
      Top             =   1440
      Width           =   4335
   End
   Begin VB.TextBox fRecCount 
      Enabled         =   0   'False
      Height          =   285
      Left            =   5160
      TabIndex        =   3
      Text            =   "0"
      Top             =   120
      Width           =   975
   End
   Begin VB.TextBox fFBinary 
      Height          =   285
      Left            =   1560
      TabIndex        =   2
      Top             =   960
      Width           =   4335
   End
   Begin MSComDlg.CommonDialog CommonDlg 
      Left            =   240
      Top             =   0
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.Line Line2 
      X1              =   120
      X2              =   6240
      Y1              =   4080
      Y2              =   4080
   End
   Begin VB.Label Label7 
      Caption         =   "fldVarBinary"
      Height          =   255
      Left            =   240
      TabIndex        =   4
      Top             =   1470
      Width           =   615
   End
   Begin VB.Line Line1 
      X1              =   120
      X2              =   6360
      Y1              =   600
      Y2              =   600
   End
   Begin VB.Label Label3 
      Caption         =   "Records in Table"
      Height          =   255
      Left            =   3840
      TabIndex        =   1
      Top             =   135
      Width           =   1455
   End
   Begin VB.Label label0 
      Caption         =   "fldFixedBinary"
      Height          =   255
      Left            =   240
      TabIndex        =   0
      Top             =   990
      Width           =   975
   End
   Begin VB.Menu itemFile 
      Caption         =   "File"
      Begin VB.Menu itemNew 
         Caption         =   "New..."
      End
      Begin VB.Menu itemOpen 
         Caption         =   "Open..."
      End
      Begin VB.Menu itemClose 
         Caption         =   "Close"
      End
   End
   Begin VB.Menu itemTest 
      Caption         =   "Test"
      Begin VB.Menu itemAdd 
         Caption         =   "Add 100 records"
      End
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Const kSerialNumber = ""

Dim dbeValentina As Valentina
Dim db As VDataBase

Private Sub btnAdd_Click()
    Dim bo As VBaseObject
    
    Set bo = db.BaseObject("table1")
    
    bo.SetBlank
    CollectPanes
    bo.AddRecord
    
    PopulatePanes
End Sub

Private Sub btnDelete_Click()
    Dim bo As VBaseObject
    
    Set bo = db.BaseObject("table1")
    
    bo.DeleteRecord
    PopulatePanes
End Sub

Private Sub btnFirst_Click()
    db.BaseObject("table1").FirstRecord
    PopulatePanes
End Sub

Private Sub btnLast_Click()
    db.BaseObject("table1").LastRecord
    PopulatePanes
End Sub

Private Sub btnNext_Click()
    db.BaseObject("table1").NextRecord
    PopulatePanes
End Sub

Private Sub btnPrev_Click()
    db.BaseObject("table1").PrevRecord
    PopulatePanes
End Sub

Private Sub btnUpdate_Click()
    Dim bo As VBaseObject
    
    Set bo = db.BaseObject("table1")
    
    CollectPanes
    bo.UpdateRecord
    
    PopulatePanes
End Sub

Private Sub Form_Load()
    Set dbeValentina = New Valentina
    
    ' If you want debug Valentina calls then uncomment this
    ' line and watch DbgView or message window of Visual Studio
    dbeValentina.DebugLevel = 2
    
    ' Init Valentina engine with 3MB of cache.
    dbeValentina.Init 3, kSerialNumber
End Sub


Private Sub Form_Unload(Cancel As Integer)
    ' We must ShutDown Valentina engine to close
    ' all files and clear RAM.
    dbeValentina.ShutDown
    Set dbeValentina = Nothing
End Sub


Private Sub itemAdd_Click()
    AddRecords (100)
End Sub

Private Sub itemClose_Click()
    db.Close
    Set db = Nothing
End Sub

Private Sub itemNew_Click()
  Dim fPath As String
  
  CommonDlg.DialogTitle = "New database"
  CommonDlg.Filter = "Valentina DB Files (*.vdb)|*.vdb"
  CommonDlg.ShowSave
  fPath = LCase(CommonDlg.FileName)
  
  CreateDatabase fPath
End Sub

Private Sub itemOpen_Click()
  Dim fPath As String
  
  CommonDlg.DialogTitle = "Open database"
  CommonDlg.Filter = "Valentina DB Files (*.vdb)|*.vdb"
  CommonDlg.ShowOpen
  fPath = LCase(CommonDlg.FileName)

  OpenDatabase fPath
End Sub

Private Sub CreateDatabase(inPath As String)
    Dim bo As VBaseObject
    Dim fld As VField

    Set db = New VDataBase
    db.Create inPath
    
    ' Create table and its fields
    Set bo = db.CreateBaseObject("table1")
    
    Set fld = bo.CreateFixedBinaryField("fldFBinary", 255)
    Set fld = bo.CreateVarBinaryField("fldVBinary", 255)
        
End Sub

Sub OpenDatabase(inPath As String)
    Set db = New VDataBase
    db.Open inPath
    
    PopulatePanes
End Sub

Sub AddRecords(inCount As Long)
    Dim i As Long
    Dim bo As VBaseObject
    Dim arr(1 To 100) As Byte
        
    Set bo = db.BaseObject("table1")
    
    For i = 1 To inCount
        arr(i) = 65 + i
    
        bo.SetBlank
            bo.Field("fldFBinary").Value = arr()
            bo.Field("fldVBinary").Value = arr()
        bo.AddRecord
    Next
    
    bo.Flush
    
    ' goto first record and display it.
    bo.FirstRecord
    PopulatePanes
End Sub

Sub PopulatePanes()
    Dim bo As VBaseObject
    Dim arr() As Byte
    
    Set bo = db.BaseObject("Table1")

    ' display record count
    fRecCount.Text = bo.RecordCount

    ' fill edit field of form by values of current record
    arr() = bo.Field("fldFBinary").Value
    fFBinary.Text = arr()
    
    arr() = bo.Field("fldVBinary").Value
    fVBinary.Text = arr()
End Sub

Sub CollectPanes()
    Dim bo As VBaseObject
    
    Set bo = db.BaseObject("Table1")

    ' fill edit field of form by values of current record
    bo.Field("fldFBinary").Value = fFBinary.Text
    bo.Field("fldVBinary").Value = fVBinary.Text
End Sub
