Attribute VB_Name = "shared"
Option Explicit

Sub DisplayRecords(ByRef VC As VCursor, Optional ByVal FirstN As Long = -1)
    
    'determine the records count to be displayed
    If FirstN = -1 Then
        FirstN = VC.RecordCount
    End If
    
    Dim i As Long
    Dim Heading As String, Underlining As String
   
    Const ColWidth As Integer = 30
    
    'first print cursor 'heading'
    For i = 1 To VC.FieldCount
        Heading = Heading + VC.Field(i).Name + String$(ColWidth - Len(VC.Field(i).Name), " ")
        Underlining = Underlining + String$(ColWidth - 1, "_") + " "
    Next
    
    Debug.Print Heading
    
    'underline heading
    Debug.Print Underlining & vbCrLf
    
    Dim j As Long
    Dim Record As String
    
    'then print records
    VC.CurrentPosition = 1
    For i = 1 To FirstN
        
        Record = ""
        For j = 1 To VC.FieldCount
        
            Dim Value As String
            Value = VC.Field(j).strValue
            Record = Record + Value + Space$(ColWidth - Len(Value))
            
        Next
        
        Debug.Print Record
        VC.NextRecord
    Next
    
End Sub
