VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   3195
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   3195
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Const kSerialNumber = ""

Dim dbeValentina As Valentina
Dim db As VDataBase
Dim errStr As String

Private Sub Form_Load()
    Dim curs As VCursor
    Dim recCount As Long
  
On Error GoTo rrr
    Set dbeValentina = New Valentina
    dbeValentina.DebugLevel = 2
    
    ' If you want debug Valentina calls then uncomment this
    ' line and watch DbgView or message window of Visual Studio
    'dbeValentina.DebugLevel = 2
    
    ' Init Valentina engine with 3MB of cache.
    dbeValentina.Init 3, kSerialNumber
  
    CreateDatabase "test.vdb"
    AddRecords (10)
    
    ' Do simplest JOIN SQL query for 2 tables
    Set curs = db.SqlSelect("SELECT * FROM table1, table2")
    recCount = curs.RecordCount

    db.Close
    dbeValentina.ShutDown
    
rrr:
    errStr = Err.Description
End Sub


Private Sub Form_Unload(Cancel As Integer)
    ' We must ShutDown Valentina engine to close
    ' all files and clear RAM.
    ' dbeValentina.ShutDown
    'Set dbeValentina = Nothing
End Sub

Private Sub CreateDatabase(inPath As String)
    Dim bo As VBaseObject
    Dim bo2 As VBaseObject
    Dim fld As VField
    Dim n As Integer

    Set db = New VDataBase
    db.Create inPath
    
    ' Create table and its fields
    Set bo = db.CreateBaseObject("table1")
    Set fld = bo.CreateShortField("fldShort")
  
    ' Create second table and fields
    Set bo2 = db.CreateBaseObject("table2")
    Set fld = bo2.CreateLongField("fldLong")
    Set fld = bo2.CreateObjectPtrField("fldPtr", bo, kV_Cascade)
  
    n = db.BaseObjectCount
  
  End Sub

Sub AddRecords(inCount As Long)
    Dim i As Long
    Dim bo As VBaseObject
    Dim bo2 As VBaseObject
    Dim RecId_1 As Long
    Dim fld As VField
    
On Error GoTo rrr
    Set bo = db.BaseObject("table1")
    Set bo2 = db.BaseObject("table2")
    
    For i = 1 To inCount
        bo.SetBlank
            bo.Field("fldShort").strValue = -i
        RecId_1 = bo.AddRecord ' we get RecID of new record
    
        ' Now we create record in the second table and link
        ' to the record of first table using its RecID
        Set fld = bo2.Field("fldLong")
        fld.Value = 100 + i
        Set fld = bo2.Field("fldPtr")
        fld.Value = RecId_1
        bo2.AddRecord
    Next
    
    db.Flush
    
rrr:
    errStr = Err.Description
End Sub




