Attribute VB_Name = "sql_1_main"
Option Explicit

'this example demonstartes how to work with database structure via SQL

Sub main()
    Dim V As New Valentina
    V.Init 10
    
    Dim Db As New VDataBase
    
    'if we already have 'sample' database then simply exit
    On Error GoTo Error
    Db.Create App.Path & "\sample"
    
    '2) create baseobjects
    Dim sql As String
    sql = "CREATE TABLE tbl1 ("
    sql = sql + "fldBoolean boolean NOT NULL, "
    sql = sql + "fldByte byte NOT NULL, "
    sql = sql + "fldShort short NOT NULL, "
    sql = sql + "fldUShort ushort NOT NULL, "
    sql = sql + "fldMedium medium NOT NULL, "
    sql = sql + "fldUMedium umedium NOT NULL, "
    sql = sql + "fldLong long NOT NULL, "
    sql = sql + "fldULong ulong NOT NULL, "
    sql = sql + "fldLLong llong NOT NULL, "
    sql = sql + "fldULLong ullong NOT NULL, "
    sql = sql + "fldFloat float NOT NULL, "
    sql = sql + "fldDouble double NOT NULL, "
    sql = sql + "fldDate date NOT NULL, "
    sql = sql + "fldTime time NOT NULL, "
    sql = sql + "fldDateTime datetime NOT NULL, "
    sql = sql + "fldString string(20, 'ASCII') NOT NULL, "
    sql = sql + "fldVarChar varchar(40, 'German') NOT NULL, "
    sql = sql + "fldFixedBinary fixedbinary(512) NOT NULL, "
    sql = sql + "fldVarBinary varbinary(128) NOT NULL, "
    sql = sql + "fldBLOB blob(10240), "
    sql = sql + "fldText text(1024, 'Ukrainian'), "
    sql = sql + "fldPicture picture(5120), "
    sql = sql + "fldObjectPtr ObjectPtr REFERENCES tbl2 ON DELETE CASCADE )"
    Debug.Print sql
    Db.SqlExecute sql
    
    '3) populate 'tbl1' with fields
    sql = "CREATE TABLE tbl2 ("
    sql = sql + "fldString string(10), "
    sql = sql + "fldLong long )"
    Debug.Print sql
    Db.SqlExecute sql
    
    V.ShutDown
    End
    
Error:
    MsgBox Err.Description, vbCritical, "Test failed"
    V.ShutDown
End Sub
